{%- import "src/_utils.j2" as utils with context -%}
{%- import "src/_tree_utils.j2" as tree with context -%}


{%- set local_ns = namespace(description="temp_distribution") -%}

{%- set local_ns.infrastructure_item_uuid = none -%}
{%- set local_ns.infrastructure_site_item_uuid = none -%}





{%- macro processInfrastructure(globals, uuid) -%}
  {#- we'll accept only one infrastructure: -#}
  {#- it makes not sense to describe more than one, especially since we -#}
  {#- allow the infrastructure to have more than one physical site,-#} 
  {#- see below  -#}
  
  {%- if not local_ns.infrastructure_item_uuid -%}
    {%- set local_ns.infrastructure_item_uuid = uuid -%}
  {%- else -%}
    {{ utils.warningMessage(false, "in processInfrastructure, only one infrastructure will be described") }}
  {%- endif -%} 
{%- endmacro -%} 


{%- macro processInfrastructureName(globals, reply, uuid) -%}
 {{ tree.isChildOf(globals, uuid, local_ns.infrastructure_item_uuid) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%} 
  {%- if answer -%}
    {%- do globals.global_ns.distribution_vars.update({ "infrastructure_title" : reply }) -%} 
  {%- endif -%} 
{%- endmacro -%} 


{%- macro processInfrastructureAcronym(globals, reply, uuid) -%}
  {{ tree.isChildOf(globals, uuid, local_ns.infrastructure_item_uuid) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%} 
  {%- if answer -%}
    {#- if globals.global_ns.distribution_vars.infrastructure_title -#}
    {#- has already a value, that's fine, we overwrite with the acronym -#}
    {#- this may change in the future  -#}
    {%- do globals.global_ns.distribution_vars.update({ "infrastructure_title" : reply }) -%}
  {%- endif -%}
{%- endmacro -%}


{%- macro processInfrastructureURL(globals, reply, uuid) -%}
  {{ tree.isChildOf(globals, uuid, local_ns.infrastructure_item_uuid) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%}  
  {%- if answer is true -%}
    {%- do globals.global_ns.distribution_vars.update({ "infrastructure_url" : reply }) -%} 
  {%- endif -%}
{%- endmacro -%}



{%- macro createInfrastructurePhysicalSite(globals, uuid) -%}
  {{ tree.isChildOf(globals, uuid, local_ns.infrastructure_item_uuid) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%}
  {%- if answer is true -%}
    
    {%- set local_ns.infrastructure_site_item_uuid = uuid -%}

    {{ utils.deepCopy(globals.global_ns.distribution_vars.infrastructure_site) }}
    {%- set site = utils.global_ns.var_stack.pop() -%}
    {%- do globals.global_ns.distribution_vars.infrastructure_sites.append(site) -%} 
  {%- endif -%}
{%- endmacro -%}



{%- macro processInfrastructurePhysicalSiteName(globals, reply, uuid) -%}
  {#- the following should be an assertion -#}
  {{ tree.isChildOf(globals, uuid, local_ns.infrastructure_site_item_uuid) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%}
  {%- if answer is true -%}
    {%- set nb_sites = globals.global_ns.distribution_vars.infrastructure_sites|length -%}
    {%- set last_site = globals.global_ns.distribution_vars.infrastructure_sites[nb_sites - 1]  -%}
    {%- do last_site.update({ "title" : reply }) -%}
  {%- endif -%}
{%- endmacro -%}


{%- macro processInfrastructurePhysicalSiteURL(globals, reply, uuid) -%}
  {#- the following should be an assertion -#}
  {{ tree.isChildOf(globals, uuid, local_ns.infrastructure_site_item_uuid) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%}
  {%- if answer is true -%}
    {%- set nb_sites = globals.global_ns.distribution_vars.infrastructure_sites|length -%}
    {%- set last_site = globals.global_ns.distribution_vars.infrastructure_sites[nb_sites - 1]  -%}
    {%- do last_site.update({ "url" : reply }) -%}
  {%- endif -%}
{%- endmacro -%}



